#pragma once
#include "ImageFormats.h"

namespace ImageFormats
{
	class ISOParser : public AICDImageFormatParser
	{
	private:
		class ISOImage : public ParsedCDImageBase
		{
		public:
			ISOImage(const ConstManagedPointer<AIFile> &pFile)
				: ParsedCDImageBase(pFile, (unsigned)(pFile->GetSize() / CD_SECTOR_SIZE))
			{
			}

			virtual size_t ReadSectorsBoundsChecked(unsigned FirstSector, void *pBuffer, unsigned SectorCount)
			{
				m_pFile->Seek(((ULONGLONG)FirstSector) * CD_SECTOR_SIZE, FileFlags::FileBegin);
				return m_pFile->Read(pBuffer, SectorCount * CD_SECTOR_SIZE);
			}

		};
	public:
		virtual ProbeResult Probe(const TempString &FileExtension, const ConstManagedPointer<AIFile> &pFile, const FilePath &FullFilePath, bool SecondPass)
		{
			return FileExtension.icompare(_T("iso")) ? NoMatch : NameOnlyMatch;
		}

		virtual ManagedPointer<AIParsedCDImage> OpenImage(const TempString &FileExtension, const ConstManagedPointer<AIFile> &pFile, const FilePath &FullFilePath)
		{
			if (!pFile || !pFile->Valid())
				return NULL;
			return new ISOImage(pFile);
		}

	};
}