#pragma once
#include <bzscmn/file.h>
#include <vector>

class VirtualCDClient
{
private:
	BazisLib::ManagedPointer<BazisLib::OSFile> m_pDevice;

public:
	static bool Win32FileNameToKernelFileName(LPCWSTR lpWin32Name, LPWSTR lpKernelName, size_t MaxKernelNameSize);

public:
	VirtualCDClient();
	BazisLib::ActionStatus ConnectDisk(LPCWSTR lpKernelFilePath, char SuggestedLetter);
	BazisLib::ActionStatus DisconnectDisk(LPCWSTR lpKernelFilePath);
	bool IsDiskConnected(LPCWSTR lpKernelFilePath);

	bool Valid()
	{
		return m_pDevice && m_pDevice->Valid();
	}

	struct VirtualCDEntry
	{
		BazisLib::DynamicStringW ImageFile;
		char DriveLetter;

		VirtualCDEntry(const wchar_t *pImageFile, char driveLtr)
			: ImageFile(pImageFile)
			, DriveLetter(driveLtr)
		{
		}
	};

	typedef std::vector<VirtualCDEntry> VirtualCDList;

	VirtualCDList GetVirtualDiskList(const wchar_t *pFilter = NULL);

	
};